'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var buildCheck = function buildCheck(NodeGit) {
  return function (src) {
    return NodeGit.Repository.open(src.repo().workdir()).then(function (readonlyRepo) {
      return Promise.all(_ramda2.default.map(function (attr) {
        return NodeGit.Attr.get(readonlyRepo, 0, src.path(), attr);
      }, ['text', 'diff', 'merge', 'filter'])).then(function (attributes) {
        var _attributes = _toArray(attributes),
            text = _attributes[0],
            lfsAttributes = _attributes.slice(1);

        return _ramda2.default.all(_ramda2.default.identity, attributes) && _ramda2.default.all(_ramda2.default.pipe(_ramda2.default.toLower, _ramda2.default.equals('lfs')), lfsAttributes) && _ramda2.default.contains('false', _ramda2.default.toLower(text)) ? _constants.Error.CODE.OK : _constants.Error.CODE.PASSTHROUGH;
      }).catch(function () {
        return _constants.Error.CODE.PASSTHROUGH;
      });
    });
  };
};

exports.default = buildCheck;